.NH
Other Wrapper Generators
.NH 2
SWIG
.PP
Many people have worked on integrating C++ code with Python,
which is a complex task as suggested by the continued
presence of the Python Special Interest Group for C++[.C++-SIG.].
Currently the most commonly used wrapping tool is SWIG 1.1[.SWIG.]
from David Beazley at the University of Chicago.
SWIG builds C/C++ extensions for several scripting languages.
Although not designed specifically for C++ nor for Python,
it works well with them.
.PP
SWIG supports many C/C++ features
(simple class definitions, public constructors and destructors,
virtual functions, public inheritance, global variables).
However,
SWIG does not support several C++ features that we use:
function overloading, operator overloading, exceptions, namespaces,
private destructors, standard C++ strings and containers.
.PP
Another problem with SWIG is
that it generates inefficient code.
SWIG uses a ``shadow class'' technique to export a C++ class into Python.
For a C++ class, all member functions,
including the constructors and destructors,
are made into Python extension module functions.
Those functions are encapsulated into a Python class
by a companion Python script,
thus shadowing the original C++ class.
The advantage of shadow classes is that they are a simple means
of allowing C++ classes to subclassed in Python.
The disadvantages are
that you need the companion script in addition to the extension module,
and that class method invocation goes through a double dispatch
before the C++ function is called.
The double dispatch is costly
as there is a significant overhead for the extra Python function call.
.NH 2
PYFFLE
.PP
Another wrapping tool that deserves special mention is PYFFLE[.PYFFLE.]
from Patrick Miller at Lawrence Livermore National Laboratory.
PYFFLE understands C++ better than SWIG.
Its failings, for our purposes, were
that it doesn't parse C++ declarations to figure out what to wrap,
that it is missing support for C++ exceptions and namespaces,
and that it requires smart pointers for C++ resource management.
